wg_data = {};
wg_data["mobs"] = {};
wg_data["fishing"] = {};
wg_data["vendors"] = {};
wg_data["objects"] = {};
wg_data["quests"] = {};
wg_data["disenchants"] = {};
wg_data["auction"] = {};
wg_data["special"] = {};
wg_data["profiles"] = {};
wg_data["version"] = 2.0;

------->>>>>>>>>>>>>>>
--Constant value
wg_NP_Battlefield 		= { "Warsong Gulch", "Alterac Valley", "Arathi Basin", "Eye of the Storm" };
wg_NP_N_Battlefield 	= 4;
wg_NP_Instance			= { "Blackwing Lair", "Molten Core", "Onyxia's Lair", "Zul'Gurub", "The Temple of Ahn'Qiraj", "The Ruins of Ahn'Qiraj", "Naxxramas", "Karazhan", "The Eye" };
wg_NP_N_Instance		= 9;

--globel function states
WG_NEEDDUELUNIT			= nil;
wg_InBattlefield		= nil;
wg_InInstance			= nil;

--temporary value
temp_duelRival			= nil;
temp_BFPlayerInfo		= {};
temp_BFPVPInfo			= {};
temp_BossTracking		= {};
--------->>>>>>>>>>>>>>>>>>>


-- Event Handlers
wg_last_action = nil;
wg_last_name = nil;
local wg_eventHandlers 			= {};
wg_objectTracking 			= nil;
wg_disenchantTracking 		= nil;
wg_bagTracking 				= nil;
wg_slotTracking 			= nil;
wg_npcTracking 				= nil;
wg_questTracking 			= nil;
wg_newQuestTracking 		= nil;
wg_mobTracking 				= nil;
wg_mobHealthTracking 		= nil;
wg_mobHealthStats 			= {};
wg_factionGamer 			= nil;
wg_objectTrackingTime 		= nil;
wg_bagslotTrackingTime 		= nil;
wg_npcTrackingTime 			= nil;
wg_newQuestTrackingTime 	= nil;
wg_newQuestCountBeforeTracking = nil;
wg_forceHonorClaiming 		= nil;
wg_useStealTime 			= nil;
wg_skinMobTime 				= nil;
--------------->>>>>>>>>>>>>
wg_duelRivalTracking		= nil;
wg_BFLoseTracking			= nil;
------------->>>>>>>>>>>>>>
wg_OldPickupContainerItem 	= nil; 
wg_OldLogoutFunc 			= nil;
wg_OldQuitFunc 				= nil;
wg_OldQuestDetailAcceptButton_OnClick = nil;
wg_OldWhoList_Update 		= nil;
wg_OldPlaceAuctionBid 		= nil;
-------------->>>>>>>>>>>>
wg_OldStartDuelUnit			= nil;
wg_OldUIErrorsFrame_OnEvent	= nil;
----------->>>>>>>>>>

-- For census, learn it from wg!
wg_queryQueue 				= {};
wg_queryWaitingFor 			= nil;
wg_queryWaitingForDetail	= nil;
wg_queryRetryingTimes 		= nil;
wg_censusProgressing 		= nil;	
wg_lastSendWhoTime 			= nil;

-- Format Patterns
wg_DISENCHANT = "Disenchant";
wg_SKINMOB = "Skinning";
wg_STEAL = "Pick Pocket";
wg_OPEN = "Opening";
wg_AUCTION = "Auction";
wg_AUCTION_WON = "Auction won";
wg_AUCTION_OUTBID = "Outbid";
wg_AUCTION_OUTBID_FORMAT = "Outbid on (.*)";

wg_APPLY_SKILL_ONTO	= "You perform (.-) on (.*).";

wg_XP_GAINED		= "You gain (.-) experience.";
wg_REPUTATION_GAINED= "Your reputation with (.+) has(.*)increased. %((.+) reputation gained%)";
wg_HONOR_GAINED		= "You gain (.-) honor"; -- need testing
				
wg_MOB_HIT_DAMAGE1   = "(.+) hits (.+) for (.*).";
wg_MOB_HIT_DAMAGE2   = "(.+) crits (.+) for (.*).";
wg_MOB_HIT_MISS1	= "(.+) misses (.*)";
wg_MOB_HIT_MISS2	= "(.+) attacks. (.*)"; --dodge

------------>>>>>>>>>>>>>>
wg_DUEL_WINNER_KNOCKOUT = "(.+) has defeated (.+) in a duel";
wg_DUEL_WINNER_RETREAT = "(.+) has fled from (.+) in a duel";
----------->>>>>>>>>>>>>>

-- Damn english syntax
wg_SPELL_PERIOD_DAMAGE = "You suffer (.+) damage from (.+)'s (.*)%.";
wg_SPELL_PERIOD_DAMAGE1 = "You are afflicted by (.+)%.";
wg_SPELL_PERIOD_DAMAGE2 = "You are (.+)%.";	-- Disarm...

wg_SPELL_PERIOD_OTHERS_DAMAGE = "(.+) suffers (.+) damage from (.+)'s (.*)%.";
wg_SPELL_PERIOD_OTHERS_DAMAGE1 = "(.+) is afflicted by (.+)%.";
wg_SPELL_PERIOD_OTHERS_DAMAGE2 = "(.+) is (.+)%.";

wg_SPELL_MSGS = { "(.+)'s (.+) hits", 
			      "(.+) performs (.+) on", 
				  "(.+)'s (.+) was"
				};

------->>>>>>>>>>>>
--Battlefield chat mask
wg_BF_PVPWIN			="(.+) dies, honorable kill Rank: (.+) (Estimated Honor Points: (.+))";
wg_BF_PVPLOSE			="You die.";

wg_BF_PVPLT_1			={"(.+) crits you for (.+).(.*)",
                		  "(.+) crits you for (.+) damage.(.*)",
                		  "(.+) hits you for (.+).(.*)",
						  "(.+) hits you for (.+) damage.(.*)",
                		  "(.+)'s (.+) hits you for (.+).(.*)",
                		  "(.+)'s (.+) hits you for (.+) damage.(.*)",
                		  "(.+)'s (.+) crits you for (.+) damage.(.*)",
                		  "(.+)'s (.+) causes you (.+) damage.(.*)",
                		  "(.+) reflects (.+) damage to you.(.*)",
                 		  "(.+) casts (.+) on you: (.+) damaged.(.*)",
                		  "(.+)'s (.+) drains (.+) from you. (.+) gains (.+).(.*)"}
						  
wg_BF_PVPLT_2 			= {"You suffer (.+) damage from (.+)'s (.+).(.*)"};

wg_BOSSDIE				="(.+) dies.";

wg_rep_messages = {
	["FACTION_STANDING_DECREASED"] = "Reputation with (.+) decreased by (.+).",
	["FACTION_STANDING_INCREASED"] = "Reputation with (.+) increased by (.+).",
};

local WG_ITEMLINK = "|c(%x+)|Hitem:(%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+)|h%[(.+)%]|h|r";
local wgDefaultQuestAccept = AcceptQuest;

-------->>>>>>>>>>>>
-- Enums
wg_HORDE            = "Horde";
wg_ALLIANCE         = "Alliance";

wg_DRUID            = "Druid";
wg_HUNTER           = "Hunter";
wg_MAGE             = "Mage";
wg_PRIEST           = "Priest";
wg_ROGUE            = "Rogue";
wg_WARLOCK          = "Warlock";
wg_WARRIOR          = "Warrior";
wg_SHAMAN           = "Shaman";
wg_PALADIN          = "Paladin";

wg_DWARF            = "Dwarf";
wg_GNOME            = "Gnome";
wg_HUMAN            = "Human";
wg_NIGHTELF         = "Night Elf";
wg_ORC              = "Orc";
wg_TAUREN           = "Tauren";
wg_TROLL            = "Troll";
wg_UNDEAD           = "Undead";
wg_BLOODELF         = "Blood Elf";
wg_DRAENEI          = "Draenei";
wg_COLLECTOR		= "(.+) Collector";

-- Skills need tracking
wg_skillsUnderTrack = {};
wg_skillsUnderTrack["Mining"] = 1;
wg_skillsUnderTrack["Opening"] = 1;
wg_skillsUnderTrack["Herb Gathering"] = 1;
-- Trade skills
wg_tradeSkills = {};
wg_tradeSkills["First Aid"] = 1;
wg_tradeSkills["Cooking"] = 1;
wg_tradeSkills["Smelting"] = 1;
wg_tradeSkills["Tailoring"] = 1;
wg_tradeSkills["Engineering"] = 1;
wg_tradeSkills["Blacksmithing"] = 1;
wg_tradeSkills["Alchemy"] = 1;
wg_tradeSkills["Enchanting"] = 1;
	
--******************************************************************************************
function wowguru_OnLoad()
	-- Register Event Handlers!!! Too many to maintain!
	wg_eventHandlers["VARIABLES_LOADED"] 		= WoWGuru_OnVariablesLoaded;
	wg_eventHandlers["PLAYER_ENTERING_WORLD"] 	= WoWGuru_OnPlayerEnteringWorld;
	wg_eventHandlers["PLAYER_LEAVING_WORLD"] 	= WoWGuru_OnPlayerLeavingWorld;
	wg_eventHandlers["TIME_PLAYED_MSG"] 		= WoWGuru_OnTimePlayedMsg;
	wg_eventHandlers["LOOT_OPENED"] 			= WoWGuru_OnLootOpened;
	wg_eventHandlers["PLAYER_TARGET_CHANGED"] 	= WoWGuru_OnPlayerTargetChanged;
	wg_eventHandlers["UPDATE_MOUSEOVER_UNIT"] 	= WoWGuru_OnUpdateMouseoverUnit;	--  Disable everyone census from 06.02.03
 	wg_eventHandlers["MERCHANT_SHOW"] 			= WoWGuru_OnMerchantShow;
	wg_eventHandlers["UNIT_COMBAT"] 			= WoWGuru_OnUnitCombat;
	wg_eventHandlers["UNIT_HEALTH"]				= WoWGuru_OnUnitHealth;
	wg_eventHandlers["CHAT_MSG_SPELL_SELF_BUFF"]= WoWGuru_OnChatMsgSpellSelfBuff;
	wg_eventHandlers["SPELLCAST_FAILED"] 		= WoWGuru_OnSpellCastFailed; 
	wg_eventHandlers["SPELLCAST_INTERRUPTED"] 	= WoWGuru_OnSpellCastFailed; 
	wg_eventHandlers["SPELLCAST_START"]			= WoWGuru_OnSpellCastStart;
	wg_eventHandlers["UNIT_SPELLCAST_SENT"]		=  WoWGuru_OnSpellCastSent;
	wg_eventHandlers["SPELLCAST_STOP"] 			= WoWGuru_OnSpellCastStop; 
	wg_eventHandlers["QUEST_LOG_UPDATE"]		= WoWGuru_OnQuestLogUpdate;
	wg_eventHandlers["QUEST_COMPLETE"]			= WoWGuru_OnQuestComplete;
	wg_eventHandlers["BANKFRAME_CLOSED"] 		= WoWGuru_OnBankFrameClosed;
	wg_eventHandlers["WHO_LIST_UPDATE"] 		= WoWGuru_OnWhoListUpdate;
	--wg_eventHandlers["INSPECT_HONOR_UPDATE"]	= WoWGuru_OnInspectHonorUpdate;
--  It will freeze the game sometimes?? anyone know how to recur this bug?
--	wg_eventHandlers["MAIL_INBOX_UPDATE"]		= WoWGuru_OnInBoxUpdate;			
	wg_eventHandlers["GUILD_ROSTER_UPDATE"]		= WoWGuru_OnGuildRosterUpdate; 
	wg_eventHandlers["TRADE_SKILL_SHOW"]		= WoWGuru_OnTradeSkillShow;
	wg_eventHandlers["GOSSIP_SHOW"]				= WoWGuru_OnGossipShow;
	wg_eventHandlers["CHAT_MSG_COMBAT_XP_GAIN"] 	= WoWGuru_OnGainXP;
	--wg_eventHandlers["CHAT_MSG_COMBAT_MISC_INFO"] 	= WoWGuru_OnGainReputation;
	wg_eventHandlers["CHAT_MSG_COMBAT_HONOR_GAIN"] 	= WoWGuru_OnGainHonor;
	wg_eventHandlers["CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE"] 	= WoWGuru_OnChatMsgMobSpellDamage; 
	wg_eventHandlers["CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE"] 	= WoWGuru_OnChatMsgMobSpellPeriodDamage;
	wg_eventHandlers["CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS"] 	= WoWGuru_OnChatMsgMobHitDamage; 
	wg_eventHandlers["CHAT_MSG_COMBAT_CREATURE_VS_SELF_MISSES"] = WoWGuru_OnChatMsgMobHitMissed;
	wg_eventHandlers["CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE"] = WoWGuru_OnChatMsgMobSpellPartyDamage;
	wg_eventHandlers["CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE"] 	= WoWGuru_OnChatMsgMobSpellPartyPeriodDamage; 
	wg_eventHandlers["CHAT_MSG_COMBAT_CREATURE_VS_PARTY_HITS"]  = WoWGuru_OnChatMsgMobHitPartyDamage;
	wg_eventHandlers["CHAT_MSG_COMBAT_CREATURE_VS_PARTY_MISSES"]= WoWGuru_OnChatMsgMobHitPartyMissed;
	wg_eventHandlers["ADDON_ACTION_BLOCKED"] = WoWGuruAddonBlocked;
	wg_eventHandlers["MACRO_ACTION_BLOCKED"] = WoWGuruAddonBlocked;
	wg_eventHandlers["ADDON_ACTION_FORBIDDEN"] = WoWGuruAddonBlocked;
	wg_eventHandlers["CHAT_MSG_COMBAT_FACTION_CHANGE"] = WoWGuruRepChange;
----------->>>>>>>>>>>>>>>>
	wg_eventHandlers["DUEL_REQUESTED"]							=WoWGuru_OnDuelRequested;
	wg_eventHandlers["CHAT_MSG_SYSTEM"]							=WoWGuru_OnChatMsgSystem;
	wg_eventHandlers["ZONE_CHANGED_NEW_AREA"]					=WoWGuru_OnZoneChangedNewArea;
	wg_eventHandlers["CHAT_MSG_COMBAT_FRIENDLY_DEATH"]			=WoWGuru_OnBFChatLose;
	wg_eventHandlers["CHAT_MSG_COMBAT_HOSTILEPLAYER_HITS"]		=WoWGuru_OnBFChatTrack;
	wg_eventHandlers["CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE"]		=WoWGuru_OnBFChatTrack;
	wg_eventHandlers["CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE"]=WoWGuru_OnBFChatTrack;
	wg_eventHandlers["CHAT_MSG_COMBAT_HOSTILE_DEATH"]			=WoWGuru_OnBossChatDeath;
------>>>>>>>>>>>>>>>>>>>>>>>
	
	for event in pairs(wg_eventHandlers) do
 	 	this:RegisterEvent(event); 
  	end
  	  	
  	-- Record old funcs
  	wg_OldPickupContainerItem = PickupContainerItem;
  	wg_OldLogoutFunc = Logout;
   	wg_OldQuitFunc = Quit; 
   	wg_OldQuestDetailAcceptButton_OnClick = QuestDetailAcceptButton_OnClick;
	AcceptQuest = wgAcceptQuest
	wg_OldWhoList_Update = WhoList_Update;
	wg_OldPlaceAuctionBid = PlaceAuctionBid;
---->>>>>>>>>>>>>>>>>>>>>>>>>>
	wg_OldStartDuelUnit			=StartDuelUnit;
	wg_OldUIErrorsFrame_OnEvent	=UIErrorsFrame_OnEvent;
---->>>>>>>>>>>>>>>>>>>>>>>>>>
	
	-- Register Census Command
	SLASH_WG1 = "/wowguru";
	SLASH_WG2 = "/wg";
	SlashCmdList["WG"] = WoWGuru_ShowMainFrame;
	
	SLASH_WGWHO1 = "/wgcensus";
	SLASH_WGWHO2 = "/wgwho";
	SlashCmdList["WGWHO"] = WoWGuru_BeginCensus;
	wg_data["quests"] = {};
				
	-- Ok
 	ShowMsg("WoW Guru Data Collection loaded successfully - http://www.wowguru.com/");
end

function wgAcceptQuest(...)
	--ShowMsg("title is"..GetTitleText());
	--wg_questTracking = wowguru_getQuestLogUniqueName(GetTitleText());
	--ShowMsg("quest is"..wg_questTracking);
	--wg_data["quests"][wg_questTracking] = {};
	wg_npcTracking = UnitName("npc");
	--ShowMsg("NPC is"..wg_npcTracking);
	--wg_data["quests"][wg_questTracking]["NPCStart"] = wg_npcTracking;
	wg_newQuestTracking = GetTitleText();

	wgDefaultQuestAccept(...);

	
	if(wg_npcTracking  and  wg_newQuestTracking) then
	    wg_newQuestTrackingTime = GetTime();
	else
	    wg_newQuestTrackingTime = nil;
	end
	
	_, wg_newQuestCountBeforeTracking = GetNumQuestLogEntries();
end

--******************************************************************************************
function wowguru_OnEvent(event)
	local eventHandle = wg_eventHandlers[event];
	if(eventHandle) then
		--ShowMsg(event);
		eventHandle();
	end	
end	

function WoWGuruAddonBlocked()

end


--******************************************************************************************
function wowguru_OnUpdate()
	if(wg_AQEnabled  and  wg_AQStarted) then
		ProcessAQGossipLogic();
	end
		
	if(wg_censusProgressing) then
		ProcessCensusLogic();
	end
----------------->>>>>>>>>>>>>>>>>>>>>>
	WoWGuru_OnDuelUpdate();
------------------>>>>>>>>>>>>>>>>>>>>>
end

--** For UIs ****************************************************************************************
function WoWGuru_ShowMainFrame()
	wg_main:Show();
end

--******************************************************************************************
function WoWGuru_OnVariablesLoaded()
	local saveTempBids;
	if(wg_data  and  wg_data["auction"]  and  wg_data["auction"]["TempBids"]) then
		saveTempBids = wg_data["auction"]["TempBids"];
	end
	
	if(not wg_data["special"][GetRealmName()]) then
		wg_data["special"][GetRealmName()] = {};
		wg_data["special"][GetRealmName()][1] = {};
		wg_data["special"][GetRealmName()][2] = {};
	end
	
	if(not wg_data["profiles"][GetRealmName()]) then
		wg_data["profiles"][GetRealmName()] = {};
	end
	
	if(saveTempBids) then
			wg_data["auction"]["TempBids"] = {}; -- saveTempBids;
	end
end

function WoWGuruRepChange()
	mobname = wg_last_name;
	for key,str in pairs(wg_rep_messages) do
		found, _, faction, amt = str.find(arg1,str);
		if found then
			if key == "FACTION_STANDING_DECREASED" then
				wg_data[wg_last_action][mobname]["repdown"] = faction..":"..amt;
			else
				wg_data[wg_last_action][mobname]["repup"] = faction..":"..amt;
			end
		end

	end
	
end

--******************************************************************************************
function WoWGuru_OnPlayerEnteringWorld()
	local thisPlayer = ClaimPlayer(UnitName("player"));
	
	-- Set locale
	wg_data["locale"] = GetLocale();
	if(wg_data["locale"] == "enUS"  and  GetCVar("realmList") == "eu.logon.worldofwarcraft.com") then
		wg_data["locale"] = "enGB";
	end
		
	-- Hook is ugly but the given leaving event is crap!	
  	PickupContainerItem = WowGuru_PickupContainerItem;
  	--QuestDetailAcceptButton_OnClick = WowGuru_QuestDetailAcceptButton_OnClick;
  	Logout = WowGuru_Logout;
  	Quit = WowGuru_Quit;
	PlaceAuctionBid = WowGuru_PlaceAuctionBid;
	
----->>>>>>>>>>>>>>>>>>>>>>>
	StartDuelUnit			= WowGuru_StartDuelUnit;
	UIErrorsFrame_OnEvent	= WowGuru_UIErrorsFrame_OnEvent;
----->>>>>>>>>>>>>>>>>>>>>>>
	
	-- Init Player Faction
  	wg_factionGamer = UnitFactionGroup("player");
  	if(wg_factionGamer == wg_ALLIANCE) then  
  		wg_factionGamer = 1;
  	else
  		wg_factionGamer = 2;
  	end	
  			
	RequestTimePlayed();
end

--******************************************************************************************
function WoWGuru_OnPlayerLeavingWorld()
	-- Restore funcs
	PickupContainerItem = wg_OldPickupContainerItem;
	QuestDetailAcceptButton_OnClick = wg_OldQuestDetailAcceptButton_OnClick;
	Logout = wg_OldLogoutFunc;
	Quit = wg_OldQuitFunc;
	PlaceAuctionBid = wg_OldPlaceAuctionBid;
	
------>>>>>>>>>>>>>>>>>>>>>>
	StartDuelUnit			= wg_OldStartDuelUnit;
	UIErrorsFrame_OnEvent	= wg_OldUIErrorsFrame_OnEvent;
------>>>>>>>>>>>>>>>>>>>>>>
  	
  	SaveMobHealth();
--	SaveCTRaidTrackerData();
	
-------->>>>>>>>>>>>>>>>
	if (wg_InBattlefield) then
		WoWGuru_BFJudgeInfo();
	end
	if (wg_InInstance) then
		WoWGuru_LeaveInstance();
	end
--------->>>>>>>>>>>>>>>>
end

--******************************************************************************************
function WowGuru_Logout()
	SavePlayerProfile();
	wg_OldLogoutFunc();  
end

--******************************************************************************************
function WowGuru_Quit()
	SavePlayerProfile();
	wg_OldQuitFunc();  
end

--******************************************************************************************
function SavePlayerProfile()
	local thisPlayer = ClaimPlayer(UnitName("player"));
	
	CollectPlayerReputationInfos(thisPlayer);
		
	CollectPlayerHonorInfos("player", thisPlayer);
		
	CollectPlayerSkillInfos(thisPlayer);
		
	CollectTalentInfos(thisPlayer);
	
	CollectPlayerStats("player", thisPlayer);
		
	CollectPlayerInventory("player", thisPlayer);
	
	CollectPlayerBags(thisPlayer);
	
	CollectPlayerQuestLog(thisPlayer);
end
   
--******************************************************************************************
function WoWGuru_OnTimePlayedMsg()
	local thisPlayer = ClaimPlayer(UnitName("player"));
	
	if(thisPlayer) then
		thisPlayer["totaltimeplayed"] = arg1;
		thisPlayer["timeplayedonlevel"] = arg2;
	end
end
	
--******************************************************************************************
function WoWGuru_OnLootOpened()
	-- heavy implementation!
	-- Fish
	if(IsFishingLoot()) then
		CollectFishingInfos();
		return;
	end	
	
	-- Objects
	if(wg_objectTracking) then
		--ShowMsg("got object");
		if(IsTimeIn(wg_objectTrackingTime, 10)) then
			--ShowMsg("Tracking object");
			CollectObjectInfos(wg_objectTracking);
			wg_objectTracking = nil;
			return;
		end	
		wg_objectTracking = nil;
	end
	
	-- Disenchant
	if (wg_disenchantTracking  and  wg_objectTrackingTime) then
		if(IsTimeIn(wg_objectTrackingTime, 3)) then
			CollectDisenchantInfos(wg_disenchantTracking);
			wg_disenchantTracking = nil;
			return;
		end	
		wg_disenchantTracking = nil;
	end
	
	-- Steal
	if(wg_useStealTime  and  wg_mobTracking) then
		if(IsTimeIn(wg_useStealTime, 3)) then
			CollectStealInfos(wg_mobTracking);
			wg_useStealTime = nil;
			return;
		end
		wg_useStealTime = nil;
	end
	
	-- Skin
	if(wg_skinMobTime  and  wg_mobTracking) then
		if(IsTimeIn(wg_skinMobTime, 3)) then 
			CollectSkinInfos(wg_mobTracking);
			wg_skinMobTime = nil;
			return;
		end
		wg_skinMobTime = nil;
	end
			
	-- Mob Loot	
	local mobName = UnitName("target");
	if(not mobName) then return end;
	if(not UnitIsDead("target")) then return end;
	if(UnitIsPlayer("target")) then return end;
	
	local thisMob = ClaimMob(mobName);
	thisMob["kills"] = SafeIncrease(thisMob["kills"]);
	
	for index = 1, GetNumLootItems(), 1 do
		if(LootSlotIsItem(index)) then
			local link = GetLootSlotLink(index);
			if(link) then
				id, enchant, subid = akz_GetItemInfoFromLink(link);
				item = id .. ":" .. enchant .. ":" .. subid;
				wowguru_addLoot(mobName, item);
			end
		elseif(LootSlotIsCoin(index)) then
			local _, lootName = GetLootSlotInfo(index);
			wowguru_addLootCoin(thisMob, extractMoneyData(lootName));
		end
	end 
end 

--******************************************************************************************
function WoWGuru_OnPlayerTargetChanged()
------------------->>>>>>>>>>>>>..
	if (wg_InBattlefield) then
		WoWGuru_GetBFPlayerInfo("target");
	end
	if (UnitExists("target") and UnitCanAttack("target","player") and UnitCanAttack("player","target")) then
		WoWGuru_GetBossInfo("target");
	end
------------------->>>>>>>>>>>>
	if(UnitExists("target")) then
		if (not UnitIsPlayer("target") and not UnitIsDeadOrGhost("target") and not UnitPlayerControlled("target")) then
			local mobname = UnitName("target");
			if (mobname == "Doomguard"  or  mobname == "Infernal") then return end;
			
			-- Collect Mob/Npc infos
			wowguru_catchMobs();

			wg_mobHealthTracking = nil;
			-- Track mob health, learn it from MobHealthMOD.
			local healthPercent = UnitHealth("target");
			if(UnitCanAttack("player", "target")  and  healthPercent) then
				wg_mobHealthTracking = {};
				wg_mobHealthTracking.name = mobname;
				wg_mobHealthTracking.currentHealthPercent = healthPercent;
				wg_mobHealthTracking.damagePoints = 0;
			end
		elseif (UnitIsPlayer("target")) then
			-- Disable from 06.02.03
			 CollectPlayerCensusInfo("target");	
			 
			-- Trouble to bring up inspect frame
			-- TryCollectPlayerDetailHonor("target");
		end
	end
end

--******************************************************************************************
function WoWGuru_OnUpdateMouseoverUnit()
------------------->>>>>>>>>>>>>..
	if (wg_InBattlefield) then
		WoWGuru_GetBFPlayerInfo("mouseover");
	end
	if (UnitExists("target") and UnitCanAttack("target","player") and UnitCanAttack("player","target")) then
		WoWGuru_GetBossInfo("mouseover");
	end
------------------->>>>>>>>>>>>
	if (UnitIsPlayer("mouseover")) then
		CollectPlayerCensusInfo("mouseover");
	end
end

--******************************************************************************************
function WoWGuru_OnUnitCombat()
	if(wg_mobHealthTracking and arg1 == "target" and arg4 and arg4 ~= 0) then
		if(arg2 == "HEAL") then
			wg_mobHealthTracking.damagePoints = wg_mobHealthTracking.damagePoints - arg4;
		else
			wg_mobHealthTracking.damagePoints = wg_mobHealthTracking.damagePoints + arg4;
		end
	end
end

--******************************************************************************************
function WoWGuru_OnUnitHealth()
	if(wg_mobHealthTracking and arg1 == "target") then
		local healthPercent = UnitHealth("target");
		
		if(healthPercent  and  healthPercent ~= 0) then
			local changePercent = wg_mobHealthTracking.currentHealthPercent - healthPercent;
			
			if(changePercent ~= 0) then
				StatMobHealth(wg_mobHealthTracking.name, wg_mobHealthTracking.damagePoints, changePercent);
				
				wg_mobHealthTracking.currentHealthPercent = healthPercent;
				wg_mobHealthTracking.damagePoints = 0;
			end
		end
	end	
end

--******************************************************************************************
function StatMobHealth(mobname, changedPoints, changedPercent)
	if(not wg_mobHealthStats[mobname]) then
		wg_mobHealthStats[mobname] = {};
		wg_mobHealthStats[mobname].points = 0;
		wg_mobHealthStats[mobname].percent = 0;
	end
	
	if(changedPoints <= 0  or  changedPercent <= 0) then return end;
		
	local mobstat = wg_mobHealthStats[mobname];
	if((mobstat.percent + changedPercent) ~= 0) then
		mobstat.percent = mobstat.percent + changedPercent;
		mobstat.points = mobstat.points + changedPoints;
	end
end

--******************************************************************************************
function SaveMobHealth()
	for mobname in pairs(wg_mobHealthStats) do
		local thisMob = ClaimMob(mobname);
		local mobstat = wg_mobHealthStats[mobname];
		thisMob["hp"] = mobstat.points .. "/" .. mobstat.percent;
	end
end

--******************************************************************************************
function WoWGuru_OnMerchantShow()
	CollectVendorInfos();
end

--******************************************************************************************
function WoWGuru_OnChatMsgSpellSelfBuff()
	local _, _, skill, objective = strfind(arg1, wg_APPLY_SKILL_ONTO);
		
	wg_objectTracking = nil;
	
	if(objective and skill) then
	   	if(wg_skillsUnderTrack[skill]) then
			wg_objectTracking = objective;
			wg_objectTrackingTime = GetTime();
     	end
	end
end

-- Self
--******************************************************************************************
function WoWGuru_OnChatMsgMobSpellDamage()
	local mob, spell;
	for i in pairs(wg_SPELL_MSGS) do
		_,_, mob, spell = strfind(arg1, wg_SPELL_MSGS[i]);
		if(mob and spell) then break end;
	end	
	
	if(mob and spell) then
		addMobSpellDamage(mob, spell);
	end
end

--******************************************************************************************
function WoWGuru_OnChatMsgMobSpellPeriodDamage()
	local mob, spell;
	_,_, _, mob, spell = strfind(arg1, wg_SPELL_PERIOD_DAMAGE);
	
	if(not mob or not spell) then
		_,_, spell = strfind(arg1, wg_SPELL_PERIOD_DAMAGE1);
		if(not spell) then
			_,_, spell = strfind(arg1, wg_SPELL_PERIOD_DAMAGE2);
		end	
		
		if(spell  and  (not UnitIsPlayer("target"))) then
			mob = UnitName("target");
		else 
			mob = nil;
		end 
	end
	
	if(mob and spell) then
		addMobSpellDamage(mob, spell);
	end
end

--******************************************************************************************
function WoWGuru_OnChatMsgMobHitDamage()
	local _,_, mob, _, damage = strfind(arg1, wg_MOB_HIT_DAMAGE1);
	
	if(not mob or not damage) then
		_,_, mob, _, damage = strfind(arg1, wg_MOB_HIT_DAMAGE2);
	end
	
	if(mob and damage) then
		addMobSpellDamage(mob, "Attack");
	end
end

--******************************************************************************************
function WoWGuru_OnChatMsgMobHitMissed()
	local _,_, mob = strfind(arg1, wg_MOB_HIT_MISS1);
	if(not mob) then 
		_,_, mob = strfind(arg1, wg_MOB_HIT_MISS2);
	end
	
	if(mob) then
		addMobSpellDamage(mob, "Attack");
	end
end

-- Party
--******************************************************************************************
function WoWGuru_OnChatMsgMobSpellPartyDamage()
	WoWGuru_OnChatMsgMobSpellDamage();
end

--******************************************************************************************
function WoWGuru_OnChatMsgMobSpellPartyPeriodDamage()
	local mob, spell;
	_,_, _, _, mob, spell = strfind(arg1, wg_SPELL_PERIOD_OTHERS_DAMAGE);
	
	if(not mob or not spell) then
		_,_, _, spell = strfind(arg1, wg_SPELL_PERIOD_OTHERS_DAMAGE1);
		if(not spell) then
			_,_, _, spell = strfind(arg1, wg_SPELL_PERIOD_OTHERS_DAMAGE2);
		end	
		
		if(spell  and  (not UnitIsPlayer("target"))) then
			mob = UnitName("target");
		else 
			mob = nil;
		end 
	end
	
	if(mob and spell) then
		addMobSpellDamage(mob, spell);
	end
end

--******************************************************************************************
function WoWGuru_OnChatMsgMobHitPartyDamage()
	WoWGuru_OnChatMsgMobHitDamage();
end

--******************************************************************************************
function WoWGuru_OnChatMsgMobHitPartyMissed()
	WoWGuru_OnChatMsgMobHitMissed();
end

--******************************************************************************************www
function WoWGuru_OnSpellCastStart()
	wg_skinMobTime = nil;
	wg_disenchantTracking = nil;
	
	if(arg1 == wg_DISENCHANT and wg_bagTracking and wg_slotTracking) then 
		if(IsTimeIn(wg_bagslotTrackingTime, 3)) then	
			wg_disenchantTracking = GetContainerItemLink(wg_bagTracking, wg_slotTracking);
		end
	elseif(arg1 == wg_SKINMOB) then
		wg_mobTracking = UnitName("target");
		if(wg_mobTracking) then
			addMobSkinable(wg_mobTracking);
			wg_skinMobTime = GetTime();
		end
	end
end

--******************************************************************************************
function WoWGuru_OnSpellCastStop()
	if(wg_disenchantTracking) then
		wg_objectTrackingTime = GetTime();
	elseif(wg_skinMobTime) then
		wg_skinMobTime = GetTime();
	end	
end

--******************************************************************************************
function WoWGuru_OnSpellCastFailed()
	if(wg_disenchantTracking) then
		wg_disenchantTracking = nil;
	end	
	
	if(wg_skinMobTime) then
		wg_skinMobTime = nil;
	end	
end

function WoWGuru_OnSpellCastSent()
	local pl = arg1;
	local spell = arg2;
	if(spell == wg_OPEN) then
		--ShowMsg("collecting");
		local rank = arg3;
		local target = arg4;
		if(target == "" or not target) then
			target = GameTooltipTextLeft1:GetText();
			wg_objectTracking = target;
			wg_objectTrackingTime = GetTime();
		end
	end
end

--******************************************************************************************
function WowGuru_QuestDetailAcceptButton_OnClick()
	wg_npcTracking = UnitName("npc");
	wg_newQuestTracking = GetTitleText();
	wg_OldQuestDetailAcceptButton_OnClick();
	
	if(wg_npcTracking  and  wg_newQuestTracking) then
	    wg_newQuestTrackingTime = GetTime();
	else
	    wg_newQuestTrackingTime = nil;
	end
	
	_, wg_newQuestCountBeforeTracking = GetNumQuestLogEntries();
end

function WoWGuru_OnQuestLogUpdate()
	if(wg_newQuestTracking  and  wg_npcTracking  and  wg_newQuestTrackingTime  and  wg_newQuestCountBeforeTracking) then
		local _, questcount = GetNumQuestLogEntries();
		
		if(IsTimeIn(wg_newQuestTrackingTime, 5)) then
			if(questcount - wg_newQuestCountBeforeTracking ~= 1) then
				return;
			end
			
			local questIndex = wowguru_getQuestLogIndexByName(wg_newQuestTracking);
			if(questIndex) then
				questTitle, level, _,numplayers = GetQuestLogTitle(questIndex);
				wowguru_addNPCQuest(wg_npcTracking, wg_newQuestTracking, level);
				--if(numplayers > 0) then
				--	wowguru_AddQuestPlayers(wg_newQuestTracking,numplayers);
				--end
			end
		end
		wg_newQuestTracking = nil;
		wg_npcTracking = nil;
		wg_newQuestTrackingTime = nil;
		wg_newQuestCountBeforeTracking = nil;
	end		
end

function wowguru_AddQuestPlayers(quest,num)
	wg_data["quests"][quest]["numplayers"] = num;
end

--******************************************************************************************
function WoWGuru_OnQuestComplete()
	wg_questTracking = wowguru_getQuestLogUniqueName(GetTitleText());
	if(not wg_questTracking) then
		wg_questTracking = GetTitleText();
	end

	wg_last_action = "quests";
	wg_last_name = wg_questTracking;
	wowguru_setNPCEndQuest(UnitName("npc"), wg_questTracking);
end

--******************************************************************************************
function WoWGuru_OnGainXP()
	-- npc will be nil if not at taking with it, so it is sure logic. 
	if(not wg_questTracking) then return end;
	
	local npc = UnitName("npc");
	if(not npc) then 
		wg_questTracking = nil;
		return;
	end
	
	local _,_,xp = strfind(arg1, wg_XP_GAINED);
	if(not xp) then return end;
	
	wg_npcTracking = npc;
	wg_npcTrackingTime = GetTime();
	
	wowguru_setQuestXP(wg_npcTracking, wg_questTracking, xp);
end

--******************************************************************************************
function WoWGuru_OnGainReputation()
	local _,_, repTarget, _, rep = strfind(arg1, wg_REPUTATION_GAINED);
	if(not repTarget or not rep) then return end;
	
	if(wg_npcTracking  and  wg_questTracking  and  wg_npcTrackingTime) then
		if(IsTimeIn(wg_npcTrackingTime, 3)) then
			wowguru_setQuestReputation(wg_npcTracking, wg_questTracking, repTarget, rep);
		else
			wg_npcTracking = nil;
			wg_questTracking = nil;
			wg_npcTrackingTime = nil;
		end
	end	
end

--******************************************************************************************
function WoWGuru_OnGainHonor()
-------------->>>>>>>>>>>>
	WoWGuru_OnBFChatWin();
-------------->>>>>>>>>>>>>
	local _,_, honor = strfind(arg1, wg_HONOR_GAINED);
	if(not honor) then return end;
		
	if(wg_npcTracking  and  wg_questTracking  and  wg_npcTrackingTime) then
		if(IsTimeIn(wg_npcTrackingTime, 3)) then
			wowguru_setQuestHonor(wg_npcTracking, wg_questTracking, honor);
		else	
			wg_npcTracking = nil;
			wg_questTracking = nil;
			wg_npcTrackingTime = nil;
		end
	end	
end

--******************************************************************************************
function WoWGuru_OnBankFrameClosed()
	local thisPlayer = ClaimPlayer(UnitName("player"));
	CollectPlayerBank(thisPlayer);
end

--******************************************************************************************
function CollectPlayerInventory(target, thisPlayer)
	if(not thisPlayer) then return end;
	
	thisPlayer["inv"] = {};
	local invent = thisPlayer["inv"];
	
	for index = 1, 18 do
		local link = GetInventoryItemLink(target, index);
		if (link) then
			id, enchant, subid, socket1, socket2, socket3, socketbonus = akz_GetItemInfoFromLink(link);
			item = id .. ":" .. enchant .. ":" .. subid .. ":" .. socket1 .. ":" .. socket2 .. ":" .. socket3 .. ":" .. socketbonus;
			invent[item] = index;
		end
	end
end

--******************************************************************************************
function wowguru_catchMobs()
	local target = UnitName("target");
	if(target  and  target ~= "Unknown Entity") then
		wowguru_addSpawn(target);
		wowguru_setLevel(target, UnitLevel("target"));
		wowguru_setHostility(target);
	end
end

--******************************************************************************************
function wowguru_addLoot(mobName, itemID)
	if(not itemID) then return end;
	
	local thisMob = ClaimMob(mobName);
	
	if(not thisMob["loot"]) then
		thisMob["loot"] = {};
	end
	
	thisMob["loot"][itemID] = SafeIncrease(thisMob["loot"][itemID]);
end

--******************************************************************************************
function wowguru_addLootCoin(thisMob, coins)
	if(not coins) then return end;
	
	if(not thisMob["loot"]) then
		thisMob["loot"] = {};
	end
	
	addMinMax(thisMob["loot"], "minCoins", "maxCoins", coins);
end

--******************************************************************************************
function wowguru_addSpawn(mobName)
	local thisMob = ClaimMob(mobName);
	
	if (not thisMob["locs"]) then
		thisMob["locs"] = {};
	end
	
	addToEntityLocation(thisMob["locs"]);
end

--******************************************************************************************
function wowguru_setLevel(mobName, level)
	local thisMob = ClaimMob(mobName);
	
	if ((not thisMob["level_min"]) or (thisMob["level_min"] > level)) then
		thisMob["level_min"] = level;
	end
	
	if ((not thisMob["level_max"]) or (thisMob["level_max"] < level)) then
		thisMob["level_max"] = level;
	end
end

--******************************************************************************************
function wowguru_setHostility(mobname)
	local thisMob = ClaimMob(mobname);
	
	if(UnitIsFriend("player", "target")) then
		thisMob["toa"] = 1;
	elseif(UnitIsEnemy("player", "target")) then
		thisMob["toa"] = 2;
	else 
		thisMob["toa"] = 3;
	end
end

--******************************************************************************************
function wowguru_addNPCQuest(npcname, questname, level)
	if(not npcname or not questname) then return end;
	
	-- With level to build a unique name
	questname = questname .. ":" .. level .. ":" .. wg_factionGamer;
 	local quest = ClaimQuest(questname);
 	
 	quest["NPCStart"] = npcname;
end

--******************************************************************************************
function wowguru_setNPCEndQuest(npcname, questname)
	if(not npcname or not questname) then return end;
	
 	local quest = ClaimQuest(questname);
	quest["NPCEnd"] = npcname;
end

--******************************************************************************************
function wowguru_setQuestXP(npcname, questname, xp)
	-- Quest Complete must be exist first!
	if(not npcname or not questname) then return end;
	
	local quest = wg_data["quests"][questname];
	if(not quest) then return end; 
	
	quest["xp"] = xp;
end

--******************************************************************************************
function wowguru_setQuestReputation(npcname, questname, reptarget, rep)
	-- Quest Complete must be exist first!
	if(not npcname or not questname) then return end;
	
	local quest = wg_data["quests"][questname];
	if(not quest) then return end; 
	
	quest["rep"] = reptarget .. ":" .. rep;
end

--******************************************************************************************
function wowguru_setQuestHonor(npcname, questname, honor)
	-- Quest Complete must be exist first!
	if(not npcname or not questname) then return end;
	
	local quest = wg_data["quests"][questname];
	if(not quest) then return end; 
	
	quest["hon"] = honor;
end

--******************************************************************************************
function GetPlayerLocation()
	return wowguru_RoundLoc(GetPlayerMapPosition("player"));
end

--******************************************************************************************
function wowguru_RoundLoc(locx, locy)
	return math.floor((locx * 100) + .5), math.floor((locy * 100) + .5);
end

--******************************************************************************************
function RoundFloat(val)
	if(not val) then return end;
	return math.floor(val * 10 + 0.5)/10;
end

--******************************************************************************************
-- Yes I stole this from alla's wow reader, go file a lawsuit :)
function akz_GetItemInfoFromLink(link)
	--for itemid, enchant, subid, itemname in string.gmatch(link, "|c%x+|Hitem:(%d+):(%d+):(%d+):%d+:%d+:%d+:%d+:%d+|h%[(.-)%]|h|r") do
      --return itemid, enchant, subid, itemname;
  	--end

	if link then
		for color, id, enchant, socket1, socket2, socket3, socketbonus, subId, trash, name in string.gmatch(link, WG_ITEMLINK) do
			id = tonumber(id);
			return id, tonumber(enchant), tonumber(subId), tonumber(socket1), tonumber(socket2), tonumber(socket3), tonumber(socketbonus), name;
		end
	end

end

--******************************************************************************************
function ClaimPlayer(playername)
	if(not wg_data["profiles"][GetRealmName()][playername]) then 
		wg_data["profiles"][GetRealmName()][playername] = {};
	end	
	
	local thisPlayer = wg_data["profiles"][GetRealmName()][playername];
	return thisPlayer;
end

--******************************************************************************************
function ClaimCensusPlayer(playername)
	if(not wg_data["profiles"][GetRealmName()][playername]) then 
		wg_data["profiles"][GetRealmName()][playername] = {};
	end	
	
	local thisPlayer = wg_data["profiles"][GetRealmName()][playername];
	return thisPlayer;
end

--******************************************************************************************
function ClaimMob(mobName)
	if(not wg_data["mobs"][mobName]) then
		wg_data["mobs"][mobName] = {};
	end
	
	local thisMob = wg_data["mobs"][mobName];
	return thisMob;
end

--******************************************************************************************
function ClaimFishing()
	if(not wg_data["fishing"][GetRealZoneText()]) then
		wg_data["fishing"][GetRealZoneText()] = {};
	end
	
	local thisFishing = wg_data["fishing"][GetRealZoneText()];
	return thisFishing;
end

--******************************************************************************************
function ClaimVendor(vendorname)
	if(not wg_data["vendors"][vendorname]) then
		wg_data["vendors"][vendorname] = {};
	end
	
	local thisVendor = wg_data["vendors"][vendorname];
	return thisVendor;
end

--******************************************************************************************
function ClaimContainer(containername)
	if(not wg_data["objects"]) then
		wg_data["objects"] = {};
	end
	if(not wg_data["objects"][containername]) then
		wg_data["objects"][containername] = {};
	end
	
	local thisContainer = wg_data["objects"][containername];
	if(not thisContainer["loot"]) then
		thisContainer["loot"] = {};
	end
	
	if(not thisContainer["locs"]) then
		thisContainer["locs"] = {};
	end		
		
	return thisContainer;
end

--******************************************************************************************
function ClaimDisenchant(itemname)
	id, enchant, subid, socket1, socket2, socket3, socketbonus, name = akz_GetItemInfoFromLink(itemname);
	--_, _, itemname = string.find(itemname, "Hitem:(.+):%d+%\124");

	if(not wg_data["disenchants"][name]) then
		wg_data["disenchants"][name] = {};
	end
	
	local thisDisenchant = wg_data["disenchants"][name];
	return thisDisenchant;
end

--******************************************************************************************
function ClaimQuest(questname)
	if(not wg_data["quests"][questname]) then
		wg_data["quests"][questname] = {};
	end
	
	return wg_data["quests"][questname];
end

--******************************************************************************************
function ShowMsg(msg)
  	DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 1);
end  	

--******************************************************************************************
function SafeIncrease(myvar)
	if(myvar) then
		myvar = myvar + 1;
	else
		myvar = 1;
	end	
	return myvar;
end

--******************************************************************************************
function CollectFishingInfos()
	--State must be pre-ensured!
	local thisFishing = ClaimFishing();
	
	for index = 1, GetNumLootItems() do
		if(LootSlotIsItem(index)) then
			local link = GetLootSlotLink(index);
			if(link) then
				thisFishing[link] = SafeIncrease(thisFishing[link]);
			end	
		end
	end 	
end

--******************************************************************************************
function CollectVendorInfos()
	--State must be pre-ensured!
	local thisVendor = ClaimVendor(UnitName("npc"));
	
	for index = 1, GetMerchantNumItems(), 1 do
		_, _, _, _, numAvailable = GetMerchantItemInfo(index);
		
		-- Seems GetMerchantItemLink fails sometime
		local link = GetMerchantItemLink(index);
		if(link) then
			--_, _, link = string.find(link, "Hitem:(.+):%d+%\124");
			id, enchant, subid, socket1, socket2, socket3, socketbonus = akz_GetItemInfoFromLink(link);
			item = id .. ":" .. enchant .. ":" .. subid .. ":" .. socket1 .. ":" .. socket2 .. ":" .. socket3 .. ":" .. socketbonus;

			if(numAvailable == -1) then numAvailable = 0 end;
			thisVendor[item] = numAvailable;
		end	
	end 	
end

--******************************************************************************************
function CollectObjectInfos(objectname)
	--State must be pre-ensured!
	local thisContainer = ClaimContainer(objectname);
	thisContainer["finds"] = SafeIncrease(thisContainer["finds"]);
	
	-- locs
	addToEntityLocation(thisContainer["locs"]);
	
	local items = thisContainer["loot"];
	for index = 1, GetNumLootItems() do
		if(LootSlotIsItem(index)) then
			local link = GetLootSlotLink(index);
			if(link) then
				--ShowMsg("link "..link);
				--local printable = gsub(link, "\124", "\124\124");
				--ShowMsg("real link"..printable);
				--local itemid = GetItemIdFromLink(link);
				id, enchant, subid, socket1, socket2, socket3, socketbonus = akz_GetItemInfoFromLink(link);
				item = id .. ":" .. enchant .. ":" .. subid .. ":" .. socket1 .. ":" .. socket2 .. ":" .. socket3 .. ":" .. socketbonus;

				items[item] = SafeIncrease(items[item]);
			end	
		end
	end 	
end

function GetItemIdFromLink(link)
	if link then
		for color, id, enchant, socket1, socket2, socket3, socketBonus, subId, trash, name in string.gmatch(link, WG_ITEMLINK) do
			id = tonumber(id);
			return id;
		end
	end
end

--******************************************************************************************
function addMobSpellDamage(mobName, spell)
	if(mobName == "Unknown Entity") then return end;
	local thisMob = ClaimMob(mobName);
	
	if(not thisMob["spells"]) then
		thisMob["spells"] = {};
	end
	
	local spells = thisMob["spells"];
	spells[spell] = SafeIncrease(spells[spell]);
end

--******************************************************************************************
function addMobSkinable(mobname)
	local thisMob = ClaimMob(mobname);
	thisMob["canSkin"] = 1; 
end

--******************************************************************************************
function setMobHealth(mobname, health)
	local thisMob = ClaimMob(mobName);
	thisMob["hp"] = health;
end

--******************************************************************************************
function addToEntityLocation(locs)
	local posX, posY = GetPlayerLocation();
	local zoneName = GetZoneText();

	if ((posX == 0) or (posY == 0)) then
		for index, locinfo in pairs(locs) do
			if ((locinfo["zone"] == zoneName) and (not locinfo["x"]) and (not locinfo["y"])) then
				return;
			end
		end
		table.insert(locs, { ["zone"] = zoneName } );
		return;
	end
	
	for index,locinfo in pairs(locs) do
		if ((locinfo["zone"] == zoneName) and (locinfo["x"] == posX) and (locinfo["y"] == posY)) then
			return;
		end
	end
	
	local newItem = { ["x"] = posX, ["y"] = posY, ["zone"] = zoneName };
	table.insert(locs, newItem);
end

--******************************************************************************************
function wowguru_getQuestLogIndexByName(name)
	local index = 1;
	while(index <= GetNumQuestLogEntries()) do
		local questTitle, _, _, _, isHeader, isCollapsed = GetQuestLogTitle(index);
		
		if(isHeader) then
		    if(isCollapsed) then
		    	ExpandQuestHeader(index);
		    end
		else
			if(questTitle == name) then return index end;
		end
		
		index = index + 1;
	end
	return nil;
end

--******************************************************************************************
function wowguru_getQuestLogUniqueName(name)
	local index = 1;
	while(index <= GetNumQuestLogEntries()) do
		local questTitle, level, _,_, isHeader, isCollapsed = GetQuestLogTitle(index);
		
		if(isHeader) then
		    if(isCollapsed) then
		    	ExpandQuestHeader(index);
		    end
		else
			if(questTitle == name) then
				return (name .. ":" .. level .. ":" .. wg_factionGamer);
			end
		end
		
		index = index + 1;
	end
	return nil;
end

--******************************************************************************************
function CollectDisenchantInfos(itemname)
	if(not itemname) then return end;
	
	--State must be pre-ensured!
	local thisDisenchant = ClaimDisenchant(itemname);
	
	for index = 1, GetNumLootItems() do
		if(LootSlotIsItem(index)) then
			thisDisenchant[index-1] = GetLootSlotLink(index);
		end	
	end
end	

--******************************************************************************************
function CollectStealInfos(mobname)
	--State must be pre-ensured!
	local thisMob = ClaimMob(mobname);
	
	thisMob["pickpocket"] = {};
	
	local picks = thisMob["pickpocket"];
	
	for index = 1, GetNumLootItems() do
		if(LootSlotIsItem(index)) then
			local link = GetLootSlotLink(index);
			if(link) then
				--_, _, link = string.find(link, "Hitem:(.+):%d+%\124");
				id, enchant, subid, socket1, socket2, socket3, socketbonus = akz_GetItemInfoFromLink(link);
				item = id .. ":" .. enchant .. ":" .. subid .. ":" .. socket1 .. ":" .. socket2 .. ":" .. socket3 .. ":" .. socketbonus;
				picks[item] = SafeIncrease(picks[item]);
			end	
		elseif(LootSlotIsCoin(index)) then
			local _, lootName = GetLootSlotInfo(index);
			local coins = extractMoneyData(lootName);
			addMinMax(picks, "minCoins", "maxCoins", coins);
		end	
	end
end	

--******************************************************************************************
function CollectSkinInfos(mobname)
	--State must be pre-ensured!
	local thisMob = ClaimMob(mobname);
		
	thisMob["skin"] = {};
	local skins = thisMob["skin"]; 
	
	for index = 1, GetNumLootItems() do
		if(LootSlotIsItem(index)) then
			local link = GetLootSlotLink(index);
			if(link) then
				--_, _, link = string.find(link, "Hitem:(.+):%d+%\124");
				id, enchant, subid, socket1, socket2, socket3, socketbonus = akz_GetItemInfoFromLink(link);
				item = id .. ":" .. enchant .. ":" .. subid .. ":" .. socket1 .. ":" .. socket2 .. ":" .. socket3 .. ":" .. socketbonus;

				skins[item] = SafeIncrease(skins[item]);
			end	
		end
	end
end
			
--******************************************************************************************
function WowGuru_PickupContainerItem(bag, slot)
	wg_bagTracking = bag;
	wg_slotTracking = slot;
	wg_bagslotTrackingTime = GetTime();
	wg_OldPickupContainerItem(bag, slot);	
end

--******************************************************************************************
function CollectPlayerReputationInfos(thisPlayer)
	thisPlayer["rep"] = {};
	
	local repHeader;
	local index = 1;
	
	while(index <= GetNumFactions()) do
		name, _, _, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed = GetFactionInfo(index);
		
		if(isHeader) then
			thisPlayer["rep"][name] = {};
			repHeader = thisPlayer["rep"][name];
			
			if(isCollapsed) then
				ExpandFactionHeader(index);
			end	
		else
			if(not atWarWith) then atWarWith = 0 end
			repHeader[name] = bottomValue .. ":" .. topValue .. ":" .. earnedValue .. ":" .. atWarWith;
		end	
		
		index = index + 1;
	end	  
end

--******************************************************************************************
function CollectPlayerHonorInfos(target, thisPlayer)
	thisPlayer["honor"] = {};
	local honor = thisPlayer["honor"];
	
	--honor["highestRank"] = UnitPVPRank(target);
	--honor["rankName"], honor["rankNumber"] = GetPVPRankInfo(honor["highestRank"], target);
	
	if(target ~= "player") then return end;

	--honor["rankProgress"] = GetPVPRankProgress()
	--honor["todayHK"], honor["todayDK"] = GetPVPSessionStats();
	--honor["yestodayHK"], honor["yestodayHonor"] = GetPVPYesterdayStats();
	--honor["thisWeekHK"], honor["thisWeekHonor"] = GetPVPThisWeekStats();
  --honor["lastWeekHK"], honor["lastWeekHonor"], honor["lastWeekStanding"] = GetPVPLastWeekStats();
	--honor["lifetimeHK"], honor["lifetimeDK"] = GetPVPLifetimeStats();
end

--******************************************************************************************
function CollectPlayerSkillInfos(thisPlayer)
	thisPlayer["skill"] = {};

	local sklHeader;
	local index = 1;
	
	while(index <= GetNumSkillLines()) do
		name, isHeader, isExpanded, skillRank, _, _, skillMaxRank = GetSkillLineInfo(index);
			
		if(isHeader) then
			thisPlayer["skill"][name] = {};
			sklHeader = thisPlayer["skill"][name];
			
			if(not isExpanded) then
				ExpandSkillHeader(index); 
			end
		else
			sklHeader[name] = skillRank .. ":" .. skillMaxRank;
		end	
		
		index = index + 1;
	end	  
end

--******************************************************************************************
function WowGuru_BeginCollectSkills()
	local name, _, _, numSpells = GetSpellTabInfo(1);
	
	--ShowMsg("Begin collect local player trade skills...");
	for spellIndex = 1, numSpells do
		local spellName, spellRank = GetSpellName(spellIndex, "spell");
		if(wg_tradeSkills[spellName]) then
			CastSpell(spellIndex, "spell");
			local count = CollectTradeSkills(spellName);
			--ShowMsg("Collect " .. count .. " trade skills for " .. spellName);
		end
	end
	CloseTradeSkill(); 
	--ShowMsg("Trade skills collect completed!");
	wg_main:Hide();
end

--******************************************************************************************
function CollectTradeSkills(spellname)
	local numTest = GetNumTradeSkills();
	if(not numTest  or  numTest == 0) then return 0 end;  
	
	local thisPlayer = ClaimPlayer(UnitName("player"));
	
	if(not thisPlayer["tradeskills"]) then
		thisPlayer["tradeskills"] =	{};
	end
	
	thisPlayer["tradeskills"][spellname] = {};
	local skills = thisPlayer["tradeskills"][spellname];
		
	local index = 1;
	while(index <= GetNumTradeSkills()) do
		local skillName, skillType, numAvailable, isExpanded = GetTradeSkillInfo(index);
		
		if(skillType == "header") then
		    if(not isExpanded) then
		    	ExpandTradeSkillSubClass(index);
		    end
		else
			table.insert(skills, skillName);
		end
		
		index = index + 1;
	end

	return table.getn(skills);
end
	
--******************************************************************************************
function CollectTalentInfos(thisPlayer)
	thisPlayer["talent"] = {};
	
	for tabIndex = 1, GetNumTalentTabs(), 1 do
		local tabName = GetTalentTabInfo(tabIndex);
		local tabinfo = "";
		
		for talentIndex = 1, GetNumTalents(tabIndex), 1 do
			nameTalent, _, _, _, currentRank, maxRank = GetTalentInfo(tabIndex, talentIndex);
			
			if(currentRank  and  currentRank > 0) then
				tabinfo = tabinfo .. (talentIndex .. ":" .. currentRank) .. ";";
			end
		end	
		
		thisPlayer["talent"][tabIndex] = tabinfo; 
	end	  
end

--******************************************************************************************
function CollectPlayerStats(target, thisPlayer)
	-- Base Infos
	thisPlayer["class"] = UnitClass(target);
	thisPlayer["level"] = UnitLevel(target);
	thisPlayer["race"]  = UnitRace(target);
	thisPlayer["sex"]   = UnitSex(target);
	
	-- Guild
	local guildName, title, rank = GetGuildInfo(target);
	thisPlayer["guild"] = guildName;
	thisPlayer["guildtitle"] = title;
	thisPlayer["guildrank"] = rank;
	
	-- Can not get below data from non-local players!
	if(target ~= "player") then return end;
	
	thisPlayer["xp"] = UnitXP(target);
	thisPlayer["xptilllevel"] = UnitXPMax(target);
	
	thisPlayer["health"] = UnitHealthMax(target); 
	thisPlayer["mana"] = UnitManaMax(target);
		
	-- Melee stuffs
	thisPlayer["Attacks"] = {};
	local thisAttack = thisPlayer["Attacks"]; 

	local mainBase, mainMod, offBase, offMod = UnitAttackBothHands(target);
	thisAttack["baseMeleeAttack"] = mainBase;
	thisAttack["modMeleeAttack"] = mainMod; 
		
	local base, posBuff, negBuff = UnitAttackPower(target);
	thisAttack["baseMeleePower"] = base;
	thisAttack["modMeleePower"] =  posBuff + negBuff;
	
	local lowDmg, hiDmg, offlowDmg, offhiDmg, posBuff, negBuff, percentmod = UnitDamage(target);
	thisAttack["MeleeDamageMin"] = math.floor(lowDmg + 0.5);
	thisAttack["MeleeDamageMax"] = math.floor(hiDmg + 0.5);
		
	local mainSpeed, offSpeed = UnitAttackSpeed(target);
	thisAttack["MeleeSpeedMainhand"] = RoundFloat(mainSpeed);
	thisAttack["MeleeSpeedOffhand"] = RoundFloat(offSpeed);
		
	-- Ranged stuffs	
	local rangedAttackBase, rangedAttackMod = UnitRangedAttack(target);
	thisAttack["baseRangedAttack"] = rangedAttackBase;
	thisAttack["modRangedAttack"] = rangedAttackMod;
	
	base, posBuff, negBuff = UnitRangedAttackPower(target);
	thisAttack["baseRangedPower"] = base;
	thisAttack["modRangedPower"] = posBuff + negBuff;
	
	local rangedAttackSpeed, minRangeAttackDamage, maxRangeAttackDamage = UnitRangedDamage(target);
	thisAttack["RangedDamageMin"] = math.floor(minRangeAttackDamage + 0.5);
	thisAttack["RangedDamageMax"] = math.floor(maxRangeAttackDamage + 0.5);
	thisAttack["RangedSpeed"] = RoundFloat(rangedAttackSpeed);
	
	-- Stats		
	thisPlayer["Stats"]	= {};
	local thisStats = thisPlayer["Stats"];
	thisStats["baseStr"], _, posBuff, negBuff = UnitStat(target, 1);
	thisStats["modStr"] = posBuff + negBuff;
	thisStats["baseStr"] = thisStats["baseStr"] - thisStats["modStr"];  
		
	thisStats["baseAgi"], _, posBuff, negBuff = UnitStat(target, 2);
	thisStats["modAgi"] = posBuff + negBuff;
	thisStats["baseAgi"] = thisStats["baseAgi"] - thisStats["modAgi"];

	thisStats["baseSta"], _, posBuff, negBuff = UnitStat(target, 3);
	thisStats["modSta"] = posBuff + negBuff;
	thisStats["baseSta"] = thisStats["baseSta"] - thisStats["modSta"];

	thisStats["baseInt"], _, posBuff, negBuff = UnitStat(target, 4);
	thisStats["modInt"] = posBuff + negBuff;
	thisStats["baseInt"] = thisStats["baseInt"] - thisStats["modInt"];
	
	thisStats["baseSpi"], _, posBuff, negBuff = UnitStat(target, 5);
	thisStats["modSpi"] = posBuff + negBuff;
	thisStats["baseSpi"] = thisStats["baseSpi"] - thisStats["modSpi"];
	
	thisStats["baseArmor"], _, _, posBuff, negBuff = UnitArmor(target);
	thisStats["modArmor"] = posBuff + negBuff; 
	
	-- Resistence
	thisPlayer["Resistence"] = {};
	local thisResist = thisPlayer["Resistence"];
	
	--thisResist["baseHoly"], _, thisResist["modHoly"]	 = UnitResistance(target, 1);
	thisResist["baseFire"],   _, thisResist["modFire"] 	 = UnitResistance(target, 2);
	thisResist["baseNature"], _, thisResist["modNature"] = UnitResistance(target, 3);
	thisResist["baseFrost"],  _, thisResist["modFrost"]  = UnitResistance(target, 4);
	thisResist["baseShadow"], _, thisResist["modShadow"] = UnitResistance(target, 5);
	thisResist["baseArcane"], _, thisResist["modArcane"] = UnitResistance(target, 6);
end

--******************************************************************************************
function CollectPlayerBags(thisPlayer)
	thisPlayer["Bags"] = {};
	
	for bagIndex = 0, 4 do
		local numSlots = GetContainerNumSlots(bagIndex);
		
		if(numSlots) then
			thisPlayer["Bags"][bagIndex] = {};
			local bag = thisPlayer["Bags"][bagIndex];
			 
			for slotIndex = 0, numSlots do
				local link = GetContainerItemLink(bagIndex, slotIndex);
				if(link) then
					id, enchant, subid, socket1, socket2, socket3, socketbonus = akz_GetItemInfoFromLink(link);
					item = id .. ":" .. enchant .. ":" .. subid .. ":" .. socket1 .. ":" .. socket2 .. ":" .. socket3 .. ":" .. socketbonus;
					bag[item] = slotIndex; 	
				end
			end
		end
	end
end

--******************************************************************************************
function CollectPlayerBank(thisPlayer)
	-- State must be pre-ensured
	thisPlayer["Bank"] = {};
	
	-- the bank container
	thisPlayer["Bank"]["Main"] = {};
	local mainbank = thisPlayer["Bank"]["Main"];
	for slotIndex = 1, GetContainerNumSlots(BANK_CONTAINER), 1 do
		local link = GetContainerItemLink(BANK_CONTAINER, slotIndex);
		if(link) then
			id, enchant, subid, socket1, socket2, socket3, socketbonus = akz_GetItemInfoFromLink(link);
			item = id .. ":" .. enchant .. ":" .. subid .. ":" .. socket1 .. ":" .. socket2 .. ":" .. socket3 .. ":" .. socketbonus;
			mainbank[item] = slotIndex; 
		end
	end

	-- the bank bags
	for bagIndex = 1, 7 do
		local bankbag = CollectBankBag(bagIndex + 4);
		if(bankbag) then
			thisPlayer["Bank"]["Bag" .. bagIndex] = bankbag;
		end
	end
end

--******************************************************************************************
function CollectBankBag(bagContainerIndex)
	local numSlots = GetContainerNumSlots(bagContainerIndex);
	if(not numSlots  or  numSlots == 0) then return nil end;
	
	local bankbag = {};
	for slotIndex = 1, numSlots do
		link = GetContainerItemLink(bagContainerIndex, slotIndex);
		if(link) then
			id, enchant, subid, socket1, socket2, socket3, socketbonus = akz_GetItemInfoFromLink(link);
			item = id .. ":" .. enchant .. ":" .. subid .. ":" .. socket1 .. ":" .. socket2 .. ":" .. socket3 .. ":" .. socketbonus;
			bankbag[item] = slotIndex;
		end
	end
	return bankbag;
end

--******************************************************************************************
function CollectPlayerCensusInfo(target)
	-- Note another CollectCensusInfo is for massive census.
	local playername = UnitName(target);
	if(not playername) then return end;
	
	local curtime = time();
	local player = ClaimCensusPlayer(playername);
	if(player["lastseen"]  and  (curtime - player["lastseen"] < 3600)) then return end;
	
	player["lastseen"] = curtime;
	CollectPlayerStats(target, player);
	CollectPlayerInventory(target, player);
	CollectPlayerHonorInfos(target, player);
	
	wowguru_CollectPlayerGuildInfo(target);
end

--******************************************************************************************
function WoWGuru_OnInspectHonorUpdate()
	if(wg_forceHonorClaiming) then
		wg_forceHonorClaiming = nil;
		InspectFrame:SetAlpha(1);
		InspectFrame:Hide();
	end
	
	if(not UnitIsPlayer("target")) then return end;
	
	local name = UnitName("target");
	if(not name) then return end;
	
	local thisPlayer = ClaimCensusPlayer(name);
	local honor = thisPlayer["honor"];
	if(not honor) then return end;
	
	honor["todayHK"], honor["todayDK"], 
	honor["yestodayHK"], honor["yestodayHonor"], 
	honor["thisWeekHK"], honor["thisWeekHonor"], 
	honor["lastWeekHK"], honor["lastWeekHonor"], honor["lastWeekStanding"],
 	honor["lifetimeHK"], honor["lifetimeDK"] = GetInspectHonorData();
	honor["rankProgress"] = GetInspectPVPRankProgress();
end

--******************************************************************************************
function CollectPlayerQuestLog(thisPlayer)
	thisPlayer["quests"] = {};
	local questlog = thisPlayer["quests"];
	
	local index = 1;
	while(index <= GetNumQuestLogEntries()) do
		local questTitle, level, _, _, isHeader, isCollapsed = GetQuestLogTitle(index);
		
		if(isHeader) then
		    if(isCollapsed) then
		    	ExpandQuestHeader(index);
		    end
		else
			local q = questTitle .. ":" .. level .. ":" .. wg_factionGamer;
			questlog[q] = index;
		--	table.insert(questlog, q);
		end
		
		index = index + 1;
	end
end

--******************************************************************************************
function IsTimeIn(lasttime, interval)
	if(not lasttime) then return nil end;
	
	local timeEllipse = GetTime() - lasttime;
	if (timeEllipse >= 0  and  timeEllipse <= interval) then
	    return 1;
	else
	    return nil;
	end
end

--******************************************************************************************
function extractMoneyData(money)
	if(not money) then return 0 end;
	
	local bg, ed, gold = string.find(money, "(.+) Gold");
	if(gold) then
		money = string.sub(money, ed + 2);
	else
		gold = 0;
	end

	local bg, ed, silver = string.find(money, "(.+) Silver");
	if(silver) then
		money = string.sub(money, ed + 2);
	else
		silver = 0;
	end

	local bg, ed, copper = string.find(money, "(.+) Copper");
	if(not copper) then
		copper = 0;
	end
	
	return gold * 10000 + silver * 100 + copper;
end

--******************************************************************************************
function addMinMax(var, tmin, tmax, value)
	if(not value or value == 0) then return end;
	
	if(not var[tmin]  or  value < var[tmin]) then 
		var[tmin] = value;
	end
	if(not var[tmax]  or  value > var[tmax]) then 
		var[tmax] = value;
	end
end

--******************************************************************************************
function WoWGuru_BeginCensus(censusType)
	if(wg_censusProgressing) then return end;
	
	-- Deploy initial query tasks
    for i = 0, 10 do	-- 1 - 55
        local query = { minLevel = i * 5 + 1, maxLevel = i * 5 + 5 };
        AppendToQueryQueue(query);
    end
	
    local query = { minLevel = 56, maxLevel = 59 };
    AppendToQueryQueue(query);
    query = { minLevel = 60, maxLevel = 60 };	-- Level 60 is the most.
    AppendToQueryQueue(query);
	
	SetWhoToUI(1);
	wg_queryWaitingFor = nil;
	wg_queryWaitingForDetail = nil;
	wg_lastSendWhoTime =   0;
	
	if(censusType) then	-- different census type, different result processing!
		wg_censusProgressing = censusType;
	else
		wg_censusProgressing = 1;	-- Normal population
	end
	
	WhoList_Update = WoWGuru_WhoList_Update;
	
	if(wg_censusProgressing == 1) then
		ShowMsg("Begin WoWGuru Census...");
	elseif(wg_censusProgressing == 2) then
		ShowMsg("Begin Guild Census...");
	end
end

--******************************************************************************************
function WoWGuru_BeginGuildCensus()
	WoWGuru_BeginCensus(2);
end

--******************************************************************************************
function WoWGuru_EndCensus(bForceStop)
	if(not wg_censusProgressing) then return end;
	
	wg_queryWaitingFor = nil;
	wg_queryWaitingForDetail = nil;
	wg_lastSendWhoTime = nil;
	wg_queryRetryingTimes = nil;
	wg_queryQueue = {};
	WhoList_Update = wg_OldWhoList_Update;
	
	if(bForceStop) then
		ShowMsg("This turn of WoWGruru Census is stopped!");
	else
		ShowMsg("This turn of WoWGruru Census is completed!");
		if(wg_censusProgressing == 2) then
			GuildRoster();	-- Activate guild roster to gather local player's guild info.
		end
	end
	
	wg_censusProgressing = nil;
	SetWhoToUI(0);
end

--******************************************************************************************
function ProcessCensusLogic()
	local curtime = GetTime();
	if(curtime - wg_lastSendWhoTime < 5) then return end;
	
	SetWhoToUI(1);
	-- Processing 
	if(wg_queryWaitingFor) then
		-- Still waiting the current query? send it again!
		if(wg_queryRetryingTimes < 4) then
			SendWho(wg_queryWaitingFor);
			wg_lastSendWhoTime = curtime;
			wg_queryRetryingTimes = wg_queryRetryingTimes + 1;
		else
			wg_queryWaitingFor = nil;	-- Abandon it
			wg_queryWaitingForDetail = nil;
		end
	else-- Process the next
		local result = ProcessQueryJobQueue(curtime);
		if(result) then
			WoWGuru_EndCensus();
		end
	end
end
--******************************************************************************************
function AppendToQueryQueue(query)
	table.insert(wg_queryQueue, query);
end

--******************************************************************************************
function ProcessQueryJobQueue(curtime)
	local numJobs = table.getn(wg_queryQueue);
	if(numJobs == 0) then return 1 end;
	
	-- Last in first out, stack!
	wg_queryWaitingForDetail = wg_queryQueue[numJobs];
	table.remove(wg_queryQueue, numJobs);
	
	wg_queryWaitingFor = MakeQueryText(wg_queryWaitingForDetail);
	SendWho(wg_queryWaitingFor);
	wg_lastSendWhoTime = curtime;
	wg_queryRetryingTimes = 1;
	return nil;
end

--******************************************************************************************
function GetFactionRaces(faction)
	local ret = {};
	if (faction == "Horde") then
		ret = { wg_ORC, wg_TAUREN, wg_TROLL, wg_UNDEAD };
	elseif (faction == "Alliance") then
		ret = { wg_DWARF, wg_GNOME, wg_HUMAN, wg_NIGHTELF };
	end
	return ret;
end

--******************************************************************************************
local function GetRaceClasses(race)
	local ret = {};
	if (race == wg_ORC) then
		ret = {wg_WARRIOR, wg_HUNTER, wg_ROGUE, wg_SHAMAN, wg_WARLOCK};
	elseif (race == wg_TAUREN) then
		ret = {wg_WARRIOR, wg_HUNTER, wg_SHAMAN, wg_DRUID};
	elseif (race == wg_TROLL) then
		ret = {wg_WARRIOR, wg_HUNTER, wg_ROGUE, wg_PRIEST, wg_SHAMAN, wg_MAGE};
	elseif (race == wg_UNDEAD) then
		ret = {wg_WARRIOR, wg_ROGUE, wg_PRIEST, wg_MAGE, wg_WARLOCK};
	elseif (race == wg_DWARF) then
		ret = {wg_WARRIOR, wg_PALADIN, wg_HUNTER, wg_ROGUE, wg_PRIEST};
	elseif (race == wg_GNOME) then
		ret = {wg_WARRIOR, wg_ROGUE, wg_MAGE, wg_WARLOCK};
	elseif (race == wg_HUMAN) then
		ret = {wg_WARRIOR, wg_PALADIN, wg_ROGUE, wg_PRIEST, wg_MAGE, wg_WARLOCK};
	elseif (race == wg_NIGHTELF) then
		ret = {wg_WARRIOR, wg_HUNTER, wg_ROGUE, wg_PRIEST, wg_DRUID};
	elseif(race == wg_DRAENEI) then
		ret = {wg_WARRIOR, wg_HUNTER, wg_PALADIN, wg_SHAMAN, wg_PRIEST, wg_MAGE};
	elseif(race == wg_BLOODELF) then
		ret = {wg_PALADIN, wg_HUNTER, wg_WARLOCK, wg_MAGE, wg_PRIEST, wg_ROGUE};
	end
	return ret;
end

--******************************************************************************************
function WoWGuru_OnWhoListUpdate()
	if(not wg_censusProgressing) then return end;
	if(not wg_queryWaitingFor) then return end;
	if(not wg_queryWaitingForDetail) then return end;

	FriendsFrame:Hide();
	
	local bOverflow = CollectCensusInfo();
	if(bOverflow) then
		-- Split into more detailed query
		local tminLevel = wg_queryWaitingForDetail.minLevel;
		local tmaxLevel = wg_queryWaitingForDetail.maxLevel;
		local tclass    = wg_queryWaitingForDetail.class;
		local trace 	= wg_queryWaitingForDetail.race;
		
		if (tminLevel ~= tmaxLevel) then
			local pivot = floor((tminLevel + tmaxLevel) / 2);
			local jobLower = { minLevel = tminLevel, maxLevel = pivot };
			AppendToQueryQueue(jobLower);
			local jobUpper = { minLevel = pivot + 1, maxLevel = tmaxLevel };
			AppendToQueryQueue(jobUpper);
		elseif (not trace) then
			local thisFactionRaces = GetFactionRaces(UnitFactionGroup("player"));
			local numRaces = table.getn(thisFactionRaces);
			for i = 1, numRaces, 1 do
				local job = { minLevel = tminLevel, maxLevel = tminLevel, race = thisFactionRaces[i] };
				AppendToQueryQueue(job);
			end					
		elseif (not tclass) then
			local thisRaceClasses = GetRaceClasses(trace);
			local numClasses = table.getn(thisRaceClasses);
			for i = 1, numClasses, 1 do
				local job = { minLevel = tminLevel, maxLevel = tminLevel, race = trace, class = thisRaceClasses[i] };
				AppendToQueryQueue(job);
			end	
		end
	end
		
	wg_queryWaitingFor = nil;
	wg_queryWaitingForDetail = nil;
	SetWhoToUI(1);
end

--******************************************************************************************
function CollectCensusInfo()
	local numWhoResults = GetNumWhoResults();
	local bOverflow = nil;
	if(numWhoResults > 49) then 
		bOverflow = 1;
		numWhoResults = 49; 
	end
	
	if(numWhoResults ~= 0) then
		if(wg_censusProgressing == 1) then
			ShowMsg("WoWGuru Census increased for: " .. numWhoResults);
		elseif (wg_censusProgressing == 2) then
			ShowMsg("WoWGuru Guild Census increased for: " .. numWhoResults);
		end
	end
	
	local curtime = time(); 
	for index = 1, numWhoResults do
		local name, guild, level, race, class = GetWhoInfo(index);
			
		if(wg_censusProgressing == 1) then
			local player = ClaimCensusPlayer(name);
			if(not player["race"]) then	
				player["race"]  = race;
				player["class"] = class;
				player["level"] = level;
				player["guild"] = guild;
				player["lastseen"] = curtime;
			end
		elseif(wg_censusProgressing == 2) then	-- Guild census
			if(guild  and  guild ~= "") then
				wowguru_CollectGuildInfo(guild, name);
			end
		end
	end
	
	return bOverflow; 
end

--******************************************************************************************
function ClaimGuild(guild)
	if(not wg_data["guilds"]) then
		wg_data["guilds"] = {};
	end
	
	if(not wg_data["guilds"][guild]) then 
		wg_data["guilds"][guild] = {};
		wg_data["guilds"][guild]["members"] = {};
	end
	
	return wg_data["guilds"][guild];
end

--******************************************************************************************
function wowguru_CollectGuildInfo(guild, name)
	local thisGuild = ClaimGuild(guild);
	
	if(not thisGuild["members"][name]) then
		thisGuild["members"][name] = ":";
	end
end

--******************************************************************************************
function wowguru_CollectPlayerGuildInfo(target)
	local unitName = UnitName(target);	
	local guild, guildRankName = GetGuildInfo(target);
	
	if(guild) then
		local thisGuild = ClaimGuild(guild);
		thisGuild["members"][unitName] = guildRankName .. ":";
	end
end

--******************************************************************************************
function MakeQueryText(query)
	local queryText = "";
	
	if (query.zone) then
		queryText = queryText .. " z-\"" .. query.zone .. "\"";
	end
	
	if (query.race) then
		queryText = queryText .. " r-\"" .. query.race .. "\"";
	end
	
	if (query.class) then
		queryText = queryText .. " c-\"".. query.class .. "\"";
	end
	
	local minLevel = query.minLevel;
	if (not minLevel) then minLevel = 1 end;
	
	local maxLevel = query.maxLevel;
	if (not maxLevel) then maxLevel = 60 end;
	
	queryText = queryText .. " " .. minLevel .. "-" .. maxLevel;
	return queryText;
end

--******************************************************************************************
function WoWGuru_WhoList_Update()
	-- WhoList_Update will popup the friend frame that will close others frame.
	if(not wg_censusProgressing) then 
		wg_OldWhoList_Update();
	end
end

--******************************************************************************************
function SaveCTRaidTrackerData()
	-- Depend on CT_RaidTraker
	if(CT_RaidTracker_RaidLog) then
		wg_data["CTRaid"] = CT_RaidTracker_RaidLog;
	end	
end

--******************************************************************************************
function WowGuru_PlaceAuctionBid(tab, index, money)
	local name, _, _, _, _, _, _, _, buyoutPrice = GetAuctionItemInfo(tab, index);
		
	local link = GetAuctionItemLink(tab, index);
	if(not link) then return end;
	
	--_, _, link = string.find(link, "Hitem:(.+):%d+%\124");
	id, enchant, subid, socket1, socket2, socket3, socketbonus = akz_GetItemInfoFromLink(link);
	item = id .. ":" .. enchant .. ":" .. subid .. ":" .. socket1 .. ":" .. socket2 .. ":" .. socket3 .. ":" .. socketbonus;

	if(money == buyoutPrice) then	-- Buyout
		CollectAuction(item, money);
	else							-- just a bid, add it to watch!
		wowgruru_addTempAution(name, item, money);
	end
			
	wg_OldPlaceAuctionBid(tab, index, money);
end

--******************************************************************************************
function CollectAuction(link, money)
	if(not wg_data["auction"][link]) then
		wg_data["auction"][link] = "1:" .. money;
		return;
	end
	
	local auction = wg_data["auction"][link];
	local _, _, times, avgmoney = string.find(auction, "(.+):(.+)");
	if(not times or not avgmoney) then
		auction = "1:" .. money;
		return;
	end
	
	local newAvgMoney = RoundFloat((avgmoney * times + money)/(times + 1)); 	
	auction = (times + 1) .. ":" .. newAvgMoney;
end

--******************************************************************************************
function wowgruru_addTempAution(name, link, money)
	if(not wg_data["auction"]["TempBids"]) then
		wg_data["auction"]["TempBids"] = {};
	end
	
	local tempBids = wg_data["auction"]["TempBids"];
	table.insert(tempBids, name .. "/" .. money .. "/" .. link);
end

--******************************************************************************************
function CheckReceivedItemInTempBids(name, succeed)
	if(not wg_data["auction"]["TempBids"]) then return end;
		 
	local tempBids = wg_data["auction"]["TempBids"];
	for key, item in tempBids do
		if(name == string.sub(item, 1, string.len(name))) then
			if(succeed) then
				local _, _, _, money, link = string.find(item, "(.+)/(.+)/(.+)"); 			
				if(money and link) then
					CollectAuction(link, money);
				end
			end
			
			table.remove(tempBids, key);
			return; 
		end  
	end
end

--******************************************************************************************
function WoWGuru_OnInBoxUpdate()
	for index = 1, GetInboxNumItems() do
		local itemName = GetInboxItem(index);
		_, _, _, subject = GetInboxHeaderInfo(index);
			
		if(itemName) then
			if(string.sub(subject, 1, string.len(wg_AUCTION)) == wg_AUCTION) then
				local succeed = nil;
				if(string.sub(subject, 1, string.len(wg_AUCTION_WON)) == wg_AUCTION_WON) then
					succeed = 1;
				end
				CheckReceivedItemInTempBids(itemName, succeed);
			end
		else
			if(string.sub(subject, 1, string.len(wg_AUCTION_OUTBID)) == wg_AUCTION_OUTBID) then
	 			_, _, itemName = string.find(subject, wg_AUCTION_OUTBID_FORMAT);
				if(itemName) then
					CheckReceivedItemInTempBids(itemName, nil);
				end
			end
		end	
	end
end

--******************************************************************************************
function WoWGuru_OnGuildRosterUpdate()
	local guild = GetGuildInfo("player");
	if(not guild) then return end;
	
	local thisGuild = ClaimGuild(guild);
	thisGuild["MOTG"] = GetGuildRosterMOTD();  
	thisGuild["NumMembers"] = GetNumGuildMembers(true);
		
	local guildMembers = thisGuild["members"];
	
	for index = 1, GetNumGuildMembers() do
		local name, rank, _, _, _, _, _, note = GetGuildRosterInfo(index);
		if(name) then
			if(not note) then note = "" end;
			if(not rank) then rank = "" end;
			guildMembers[name] = rank .. ":" .. note;
		end
	end
end

--******************************************************************************************
function WoWGuru_OnTradeSkillShow()
	local name, _, _, numSpells = GetSpellTabInfo(1);
	
	for spellIndex = 1, numSpells do
		local spellName, spellRank = GetSpellName(spellIndex, "spell");
		if(wg_tradeSkills[spellName]) then
			if(IsCurrentCast(spellIndex, "spell")) then
				CollectTradeSkills(spellName);
			end
		end
	end
end

--******************************************************************************************
function TryCollectPlayerDetailHonor(target)
	if(not UnitIsFriend("player", target)) then return end;
	if(not CheckInteractDistance(target, 1)) then return end;
	
	InspectUnit(target);
	if(HasInspectHonorData()) then
		WoWGuru_OnInspectHonorUpdate();
		InspectFrame:Hide();
	else
		RequestInspectHonorData();
		InspectFrame:SetAlpha(0);		-- Fade it, but not hide it, otherwise can not get the inspect data!
		wg_forceHonorClaiming = 1;		-- Remember we do the forcement!
	end
end

--******************************************************************************************
function WoWGuru_OnGossipShow()
	if(not UnitExists("target")) then return end;
	if(not UnitName("target")) then return end;
	
	-- Check AQ Collector npc
	potbottooltip:SetUnit("target");
	local npcTitle = getglobal(potbottooltip:GetName() .. "TextLeft" .. 2):GetText();
	if(not npcTitle) then return end;
		
	local _, _, colName = strfind(npcTitle, wg_COLLECTOR);
	if(not colName) then return end;
	
	-- parse its words	
	local mtext = GetGossipText();
	if(not mtext) then return end;
	
	local tparse = "(.+) (%d+)(.+) (%d+)";
	local _, _, x, m, y, n = string.find(mtext, tparse);
	if(not m  or  not n) then return end;
	
	local numNeeded, numCollected;
	if(m > n) then
		numNeeded = m;
		numCollected = n;
	else
		numNeeded = n;
		numCollected = m;
	end
			
	local curtime = time();
	wg_data["special"][GetRealmName()][wg_factionGamer][colName] = numCollected .. ":" .. numNeeded .. ":" .. curtime;
end

--**** Duel data Collect function family ***************************************************
function WowGuru_StartDuelUnit(unit)
	if (unit) then
		wg_duelRivalTracking = UnitName(unit);
		CollectDuelRivalInfo(unit);
	end
	wg_OldStartDuelUnit(unit);
end

--******************************************************************************************
function WowGuru_UIErrorsFrame_OnEvent(event, message)
	if (message == ERR_DUEL_CANCELLED 
		or message == SPELL_FAILED_TARGET_DUELING 
		or message == SPELL_FAILED_CANT_DUEL_WHILE_INVISIBLE
		or message == SPELL_FAILED_CANT_DUEL_WHILE_STEALTHED
		or message == SPELL_FAILED_NO_DUELING) then 
		temp_duelRival = nil;
		wg_duelRivalTracking = nil;
		WG_NEEDDUELUNIT = nil;
	end
	wg_OldUIErrorsFrame_OnEvent(event, message);
end

--******************************************************************************************
function WoWGuru_OnDuelRequested()
	if (arg1) then
		wg_duelRivalTracking = arg1;
		WG_NEEDDUELUNIT = true;
	end
end

--******************************************************************************************
function WoWGuru_OnChatMsgSystem()
	local success = nil;
	
	local _, _, winer, loser = string.find(arg1, wg_DUEL_WINNER_KNOCKOUT);
	if (winer and loser) then 
		if (wg_duelRivalTracking and (wg_duelRivalTracking == winer or wg_duelRivalTracking == loser)) then
			success = true;
		end
	else
		_, _, loser, winer = string.find(arg1, wg_DUEL_WINNER_RETREAT);
		if (winer and loser) then
			if (wg_duelRivalTracking and (wg_duelRivalTracking == winer or wg_duelRivalTracking == loser)) then
				success = true;
			end
		end
	end
	
	if (success) then
		if (temp_duelRival) then
			local result;
			if (winer == UnitName("player")) then 
				result = "Win";
			else 
				result = "Lose";
			end
			
			temp_duelRival["result"] = result;
			table.insert(ClaimDuel(), temp_duelRival);
			temp_duelRival = nil;
		end
		
		wg_duelRivalTracking = nil;
		WG_NEEDDUELUNIT = nil;
	end
end

--******************************************************************************************
function WoWGuru_OnDuelUpdate()
	if (WG_NEEDDUELUNIT and wg_duelRivalTracking) then
		if (UnitName("target") == wg_duelRivalTracking) then
			CollectDuelRivalInfo("target");
			WG_NEEDDUELUNIT = nil;
		end
	end
end

--******************************************************************************************
function ClaimDuel()
	if (not wg_data["duels"]) then 
		wg_data["duels"] = {}; 
	end
	return wg_data["duels"];
end

--******************************************************************************************
function CollectDuelRivalInfo(unit)
	if (unit) then
		temp_duelRival = {};
		temp_duelRival["time"]		= time();
		temp_duelRival["name"]		= UnitName(unit);
		temp_duelRival["rank"]		= UnitPVPRank(unit);
		temp_duelRival["guild"]		= GetGuildInfo(unit);
		temp_duelRival["race"]		= UnitRace(unit);
		temp_duelRival["class"]		= UnitClass(unit);
		temp_duelRival["leveldiff"]	= UnitLevel("player") - UnitLevel(unit);
		temp_duelRival["zone"]		= GetZoneText();
		temp_duelRival["subzone"]	= GetSubZoneText();
	end
end
--end Duel
	
--**** Battlefield PVP data Collect function family ******************************************
function WoWGuru_GetBFPlayerInfo(unit)
	local name	= UnitName(unit);
	local rank	= UnitPVPRank(unit);
	local guild	= GetGuildInfo(unit);
	local race	= UnitRace(unit);
	local class	= UnitClass(unit);
	local level	= UnitLevel(unit);
	
	if (name and rank and guild and race and class and level) then
		if (not temp_BFPlayerInfo[name] and
			UnitFactionGroup(unit) ~= UnitFactionGroup("player")) then
			temp_BFPlayerInfo[name] = {};
			temp_BFPlayerInfo[name]["rank"]		= rank;
			temp_BFPlayerInfo[name]["guild"]	= guild;
			temp_BFPlayerInfo[name]["race"]		= race;
			temp_BFPlayerInfo[name]["class"]	= class;
			temp_BFPlayerInfo[name]["leveldiff"]= UnitLevel("player") - level;
		end
	end
end

--******************************************************************************************
function WoWGuru_OnZoneChangedNewArea()
--ShowMsg(GetRealZoneText());
	local find = nil;
	for i = 1, wg_NP_N_Battlefield do
		if (wg_NP_Battlefield[i] == GetRealZoneText()) then
			wg_InBattlefield = i;
			find = "bf";
			break;
		end
	end
	if (not find) then
		for i = 1, wg_NP_N_Instance do
			if (wg_NP_Instance[i] == GetRealZoneText()) then
				ShowMsg("new instance:"..wg_NP_Instance[i]);
				wg_InInstance = i;
				find = "ins";
				break;
			end
		end
	end
	
	if (find ~= "bf") then
		wg_InBattlefield = nil;
		WoWGuru_BFJudgeInfo();
	end
	if( wg_InInstance ) then
		WoWGuru_LeaveInstance();
		wg_InInstance = nil;
	end
    if (find == "ins") then
		WoWGuru_EntryInstance();
	end
end

--******************************************************************************************
---on chat msg
function WoWGuru_OnBFChatLose()
	if (wg_InBattlefield) then
		local temppvp = {};
		if (arg1 == wg_BF_PVPLOSE and wg_BFLoseTracking) then
			temppvp["when"]		= time();
			temppvp["name"]		= wg_BFLoseTracking;
			temppvp["result"]	= "Lose";
			temppvp["honor"]	= 0;
			temppvp["zone"]		= wg_NP_Battlefield[wg_InBattlefield];
			temppvp["subzone"]	= GetSubZoneText();
			table.insert(temp_BFPVPInfo, temppvp);
			wg_BFLoseTracking   = nil;
		end
	end
end

--******************************************************************************************
function WoWGuru_OnBFChatWin()
	if (wg_InBattlefield) then
		local _, _, name, rank, honor = string.find(arg1, wg_BF_PVPWIN);
		local temppvp = {};
		
		if (name and rank and honor) then
			temppvp["when"]		= time();
			temppvp["name"]		= name;
			temppvp["result"]	= "Win";
			temppvp["honor"]	= honor;
			temppvp["zone"]		= wg_NP_Battlefield[wg_InBattlefield];
			temppvp["subzone"]	= GetSubZoneText();
			table.insert(temp_BFPVPInfo, temppvp);
		end
	end
end

--******************************************************************************************
function WoWGuru_OnBFChatTrack()
	if (wg_InBattlefield) then
		local rival = nil;
		local index, value;
		
		for index, value in pairs(wg_BF_PVPLT_1) do
			_, _, rival = string.find(arg1, value);
			if (rival) then
				wg_BFLoseTracking = rival;
				return nil;
			end
		end
		
		for index, value in pairs(wg_BF_PVPLT_2) do
			_, _, _, rival = string.find(arg1, value);
			if (rival) then
				wg_BFLoseTracking = rival;
				return nil;
			end
		end
	end
end

--**** store info *************************************************************************
function ClaimBattlefield()
	if (not wg_data["battleground"]) then 
		wg_data["battleground"] = {};
	end
	return wg_data["battleground"];
end

--******************************************************************************************
function WoWGuru_BFJudgeInfo()
	local index, value, pvpinfo;
	for index, value in pairs(temp_BFPVPInfo) do
		if (temp_BFPlayerInfo[value["name"]]) then
			pvpinfo = {};
			pvpinfo["when"]		= value["when"];
			pvpinfo["name"]		= value["name"];
			pvpinfo["rank"]		= temp_BFPlayerInfo[value["name"]]["rank"];
			pvpinfo["guild"]	= temp_BFPlayerInfo[value["name"]]["guild"];
			pvpinfo["race"]		= temp_BFPlayerInfo[value["name"]]["race"];
			pvpinfo["class"]	= temp_BFPlayerInfo[value["name"]]["class"];
			pvpinfo["leveldiff"]= temp_BFPlayerInfo[value["name"]]["leveldiff"];
			pvpinfo["result"]	= value["result"];
			pvpinfo["honor"]	= value["honor"];
			pvpinfo["zone"]		= value["zone"];
			pvpinfo["subzone"]	= value["subzone"];
			table.insert(ClaimBattlefield(), pvpinfo);
		end
	end
	
	temp_BFPVPInfo = {};
	temp_BFPlayerInfo = {};
end
-- Battlefield end ************************************************************************
	
-- instance boss info collect function family *********************************************
function WoWGuru_OnBossChatDeath()
	if (wg_InInstance) then
		local _, _, name = string.find(arg1, wg_BOSSDIE);
		if (name and temp_BossTracking[name] and name == temp_BossTracking[name]) then
			wg_last_action = "mobs";
			wg_last_name = name;
			local ins = ClaimInstanceInfo(wg_NP_Instance[wg_InInstance]);
			if (not ins["kills"]) then
				ins["kills"] = {};
			end
			ins["kills"][name] = time();
		end
	else
		local _, _, name = string.find(arg1, wg_BOSSDIE);
		if(name) then
			wg_last_action = "mobs";
			wg_last_name = name;
		end
	end
end

--******************************************************************************************
function ClaimInstanceInfo(zone)
	if (not wg_data["instance"]) then
		wg_data["instance"] = {};
	end
	if (not wg_data["instance"][zone]) then
		wg_data["instance"][zone] = {};
	end
	
	return wg_data["instance"][zone];
end

--******************************************************************************************
function WoWGuru_GetBossInfo(unit)
	if (wg_InInstance) then
		local name;
		if (UnitClassification(unit) == "worldboss") then
			name = UnitName(unit);
			if (not temp_BossTracking[name]) then
				temp_BossTracking[name] = name;
			end
		end
	end
end

--******************************************************************************************
function WoWGuru_EntryInstance()
	local ins = ClaimInstanceInfo(wg_NP_Instance[wg_InInstance]);
	if (not ins["start"]) then
		ins["start"] = time();
	end
end

--******************************************************************************************
function WoWGuru_LeaveInstance()
	local ins = ClaimInstanceInfo(wg_NP_Instance[wg_InInstance]);
	ins["end"] = time();
end

-- boss info end ****************************************************************************